/*
 * Ohjelmalla tulostetaan reaalilukjen bittiesityksi.
 * Vesa Lappalainen 8.11.2008
 *
 */

#include <stdio.h>

#define int short  // pakotetaan 16 bit "inteiksi" (Visual C)

char *muutaBiteiksi(char byte,char bitit[9]) {
  int i;
  char bit;
  for (i=7; i>=0; i--) {
    bit = byte & 1;
    bitit[i] = '0'+bit;
    byte = byte >> 1;
  }
  return bitit;
}


void tulostaBitit(char bytes[],int n) {
  char bitit[9] = "00000000";
  int i;
  for (i=0; i<n; i++) {
    muutaBiteiksi(bytes[i],bitit);
    printf(" %s",bitit);
  }
  printf("\n");
}


void tulostaDouble(double d) {
  printf("%7.3lf:",d);
  tulostaBitit((char *)&d,sizeof(double));

}

void tulostaFloat(float d) {
  printf("%7.3f:",d);
  tulostaBitit((char *)&d,sizeof(float));
}

void tulostaInt(int d) {
  printf("%7d:",d);
  tulostaBitit((char *)&d,sizeof(int));
}


int main(void) {
  double dluvut[] = {10,9,8,7,6,5,4,3,2,1,
                     0.875,0.8,0.75,0.5,0.25,0.1,0,
                    -0.1,-1,-2,-10};
  int    iluvut[] = {10,9,8,7,6,5,4,3,2,1,
                     0,-1,-2,-10};
  int dlen = sizeof(dluvut)/sizeof(dluvut[0]);
  int ilen = sizeof(iluvut)/sizeof(iluvut[0]);

  int i;

  for (i=0; i<dlen;i++)
    tulostaDouble(dluvut[i]);

  printf("\n");
  for (i=0; i<dlen;i++)
    tulostaFloat(dluvut[i]);

  printf("\n");
  for (i=0; i<ilen;i++)
    tulostaInt(iluvut[i]);

  return 0;
}
